/* ===================================================================== */
/*
 * This is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2006. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */

#ifndef INCL_TEST_HELPER_HPP 
#define INCL_TEST_HELPER_HPP 

#include "Foundation/ossupport/OS.hpp"
#include "Foundation/testutils/CORBATestManager.hpp"
#include "Foundation/ossupport/OS.hpp"
#include "Foundation/orbsupport/CORBA.hpp"
#include "Foundation/orbsupport/OrbSupport.hpp"
#include "Foundation/orbsupport/StrategyList.hpp"

// Class helping to recover the id of the process created in main.cpp

class TestHelper
{
public:
  Cdmw::OsSupport::OS::ProcessId getIdClient() throw();
  void setIdClient(Cdmw::OsSupport::OS::ProcessId id) throw();

  static TestHelper& getInstance() throw();
  
private:
  TestHelper();
  TestHelper(const TestHelper&);
  TestHelper& operator = (const TestHelper&);

  Cdmw::OsSupport::OS::ProcessId m_idClient;

};

#endif // end INCL_TEST_HELPER_HPP 
