/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2006. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */


// Cdmw Files
#include <Foundation/common/Assert.hpp> 
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/ossupport/SystemProperties.hpp>

#if CDMW_ORB_VDR == tao && CDMW_ORB_VER > 13
#include <tao/ORBInitializer_Registry.h>
#endif


// Local Files
#include <ftultimatefallback/FTUltimateFallbackInit.hpp>
#include <ftultimatefallback/FTORBInitializer.hpp>

#include <FaultTolerance/ftcommon/FTConfiguration.hpp>


namespace
{
    const int POA_THREAD_POOL_SIZE = 5;
}



namespace Cdmw
{
    
namespace FT
{

namespace UltimateFallback
{

void
UltimateFallbackInit::Pre_init (int& argc, char** argv)
    throw(CORBA::SystemException)
{
    // register_interceptors();
    PortableInterceptor::ORBInitializer_var initializer = new FTORBInitializer();
        
    PortableInterceptor::register_orb_initializer(initializer.in());
}

void
UltimateFallbackInit::Init (CORBA::ORB_ptr orb)
    throw(CORBA::SystemException)
{
    
/*    // Get the root POA
    CORBA::Object_var obj = orb->resolve_initial_references("RootPOA");
    PortableServer::POA_var rootPOA = PortableServer::POA::_narrow(obj.in());

    // Get the POA manager
    PortableServer::POAManager_var POAMgr = rootPOA->the_POAManager();

    // Create the policies and the strategies
    CORBA::PolicyList policies(5);
    policies.length(5);
    policies[0] = rootPOA->create_thread_policy(PortableServer::ORB_CTRL_MODEL);
    policies[1] = rootPOA->create_lifespan_policy(PortableServer::PERSISTENT);
    policies[2] = rootPOA->create_id_assignment_policy(PortableServer::USER_ID);
    policies[3] = rootPOA->create_servant_retention_policy(PortableServer::NON_RETAIN);
    policies[4] = rootPOA->create_request_processing_policy(PortableServer::USE_SERVANT_MANAGER);

    Cdmw::OrbSupport::StrategyList poaStrategies;

    // the PERSISTENT policy is incompatible with the THREADPOOL policy for TAO
#if CDMW_ORB_VDR == tao
    poaStrategies.add_PoaThreadPerConnection();
#else
    poaStrategies.add_PoaThreadPool(POA_THREAD_POOL_SIZE);
#endif

    // -- Create the POA to bind the ultimateFallback ior --
    PortableServer::POA_var uf_POA 
       = Cdmw::OrbSupport::OrbSupport::create_POA(rootPOA.in(), 
                                                  "UltimateFallbackPOA", 
                                                  POAMgr.in(), 
                                                  policies, 
                                                  poaStrategies);

    const char* fallbackid = "ultimatefallback";
    const char* type_id = "IDL:omg.org/FT/ReplicationManager:1.0";
    
    PortableServer::ObjectId_var oid__ = PortableServer::string_to_ObjectId (fallbackid);
    CORBA::Object_var ref__ = uf_POA->create_reference_with_id (oid__.in (), type_id);

    // publishes the daemon naming context corbaloc
    Cdmw::OrbSupport::OrbSupport::bind_object_to_corbaloc
                (orb, "FTUltimateFallback", ref__.in() );

    // release the policies
     for (unsigned long i = 0; i < policies.length(); i++)
          policies[i]->destroy();
          */
}


} // End of namespace UltimateFallback

} // End of namespace FT

} // End of namespace Cdmw



