/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES 
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX-SI and THALES 2006. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */

package cdmw.logging;

public class LogLevel
{
    /** 
     * Constant identifying all levels set
     */
    public static final long  ALL_LEVELS_SET = ~0L;

    /** 
     * Constant identifying all components
     */
    public static final String ALL_COMPONENT_NAMES = "*";

    /** 
     * Constant identifying all domains
     */
    public static final String ALL_DOMAINS = "*";

    /** 
     * Constant identifying the component separator
     */ 
    public static final char COMPONENT_SEP = '.';

    /**
     * Default log levels.
     */
    // this level reports a fatal error from CDMW; CDMW is no more
    // able to process safely.
    public static final long FATAL = 1L;
        
    // this level reports an erorr from CDMW.
    public static final long ERROR = 2L;

    // maybe the user has made an error, warn him.
    public static final long WARN  = 4L;

    // used for information purposes.
    public static final long INFO  = 8L;
        
    // used for debug purposes.
    public static final long DEBUG = 16L;

    /**
     * Additional debug levels for CDMW.
     */
    public static final long DEBUG_1 = 0x00000020L;
    public static final long DEBUG_2 = 0x00000040L;
    public static final long DEBUG_3 = 0x00000080L;
    public static final long DEBUG_4 = 0x00000100L;
    public static final long DEBUG_5 = 0x00000200L;
    public static final long DEBUG_6 = 0x00000400L;
    public static final long DEBUG_7 = 0x00000800L;
    public static final long DEBUG_8 = 0x00001000L;
    public static final long DEBUG_9 = 0x00002000L;

} 

