/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES 
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX-SI and THALES 2006. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 *  
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */


package cdmw.logging.test;

import cdmw.logging.*;

import cdmw.common.*;


public class FunctionLoggerUser
{
    private Logger m_logger;
    private LevelType level;

    public FunctionLoggerUser (Logger logger) {
        m_logger = logger;
        level = new LevelType ();
    }

    public void op1 () {
          cdmw.logging.Logger.CDMW_INFO(m_logger,"FunctionLoggerUser op1", new Throwable());
    }

    public int opReturn (int a, int b) {
        cdmw.logging.Logger.CDMW_INFO(m_logger,"FunctionLoggerUser opReturn", new Throwable());
        return a+b;
    }

    public void opException (Severity severity) throws FnLogException {
        cdmw.logging.Logger.CDMW_INFO(m_logger,"FunctionLoggerUser opException throwing exception!", new Throwable());
        throw new FnLogException (severity, "FunctionLoggerUser opException");
    }
}
