/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES 
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX-SI and THALES 2006. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 *  
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */


package cdmw.logging.test;

import cdmw.logging.*;

import cdmw.testutils.Testable;
import cdmw.common.*;


public class TestFunctionLogger extends Testable 
{

    public TestFunctionLogger() {
        this.name = "TestFunctionLogger";
        this.out = System.out;
    }

    public void doTests() {
        setNbOfRequestedTestOK(3);
        int retval, res;
        FunctionLoggerUser flu;
        Severity exSeverity;

        println ("Obtaining a default logger for the TEST_FUNCTION_LOGGER domain");

        Logger logger = Logger.Get_Logger ("TEST_FUNCTION_LOGGER");

        check (logger != null);

        println ("Calling the Function logger. VISUAL CHECK!.");

        flu = new FunctionLoggerUser (logger);

        println ("Calling op1 (with no return and no exception).");

        flu.op1();
        
        retval = 30;

        println ("Calling opReturn that returns value " + retval);
        res = flu.opReturn (20,10);
        check (res == retval);
 
        println ("Calling opException. This should raise an exception");

        exSeverity = Severity.FATAL;

        try 
        { 
            flu.opException (exSeverity);
        }
        catch (FnLogException ex)
        {
            println ("Called opException. This raised an exception");
            check (ex.getSeverity().equals("FATAL"));
        }
    }
}
           
       
