/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2006. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */


#ifndef INCL_ORBSUPPORT_CDMW_SERVER_REQUEST_INTERCEPTOR_HPP
#define INCL_ORBSUPPORT_CDMW_SERVER_REQUEST_INTERCEPTOR_HPP

// Cdmw Files
#include <Foundation/orbsupport/TaoServerRequestInterceptor.hpp>

namespace Cdmw
{
    
namespace OrbSupport
{


class CdmwServerRequestInterceptor : public TaoServerRequestInterceptor 
{
   public:

      CdmwServerRequestInterceptor() {}
      virtual void
      cdmw_ft_interception_point(PortableInterceptor::ServerRequestInfo_ptr ri,
                                CORBA::OctetSeq_out ocs)
         throw (CORBA::SystemException, PortableInterceptor::ForwardRequest) = 0;


   private:
      CdmwServerRequestInterceptor(const CdmwServerRequestInterceptor&);
      CdmwServerRequestInterceptor& operator=(const CdmwServerRequestInterceptor&);
};

} // End of namespace OrbSupport

} // End of namespace Cdmw

#endif // INCL_ORBSUPPORT_CDMW_SERVER_REQUEST_INTERCEPTOR_HPP

