/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2006. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */
#ifndef INCL_ORBSUPPORT_MARSHALLING_BUFFER_HPP
#define INCL_ORBSUPPORT_MARSHALLING_BUFFER_HPP

#include <Foundation/orbsupport/CORBA.hpp>
#include <tao/CDR.h>

// use this class to marshall CORBA::Any into a single buffer
// limitations : single use only (no reset of the buffer)
namespace Cdmw {
    
   namespace OrbSupport {


      class MarshallingBuffer  {
         public :
            MarshallingBuffer() {}
      
            void add_any(const CORBA::Any& value);
            CORBA::OctetSeq* get_buffer();

         protected :
            TAO_OutputCDR m_TaoOutputCdr;
      };
   }
}

#endif //INCL_ORBSUPPORT_MARSHALLING_BUFFER_HPP

