/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES 
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX-SI and THALES 2006. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */


#ifndef INCL_ORBSUPPORT_TESTSTRINGTOOBJ_HPP
#define INCL_ORBSUPPORT_TESTSTRINGTOOBJ_HPP

#include <string>

#include "Foundation/testutils/CORBATestManager.hpp"

#include "Foundation/orbsupport/CORBA.hpp"

namespace Cdmw
{

    namespace OrbSupport
    {

        /**
        *Purpose:
        *<p>    Verify string_to_object calls on the ORB
        *
        *
        */

        class TestStringToObj : public CppUnit::TestFixture
        {
            public:

		void
		setUp();
		void 
		tearDown();

                void
                string_to_object_1();

                void
                string_to_object_2();

            private:
		CORBA::ORB_var m_orb;
	
                CPPUNIT_TEST_SUITE( TestStringToObj );
                    CPPUNIT_TEST_EXCEPTION( string_to_object_1, CORBA::BAD_PARAM);
                    CPPUNIT_TEST_EXCEPTION( string_to_object_2, CORBA::BAD_PARAM);
                CPPUNIT_TEST_SUITE_END();

        } ; // End class TestStringToObj
    } // End namespace OrbSupport
} // End namespace Cdmw

#endif // INCL_ORBSUPPORT_TESTSTRINGTOOBJ_HPP

