/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES 
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX-SI and THALES 2006. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */


#include <iostream>
#include <ccm_reconnect/CCM_Server_impl.hpp>
#include <ccm_reconnect/CCM_EventChecking_impl.hpp>

//
// IDL:thalesgroup.com/ReconnectDemo/CCM_Server:1.0
//
ReconnectDemo::CCM_Server_impl::CCM_Server_impl()
{
	m_facet = new ReconnectDemo::CCM_EventChecking_impl();
}

ReconnectDemo::CCM_Server_impl::~CCM_Server_impl()
{
    std::cout << "CCM_Server_impl::~CCM_Server_impl called!" << std::endl;
}

//
// IDL:thalesgroup.com/ReconnectDemo/CCM_Server/get_for_clients:1.0
//
::ReconnectDemo::CCM_EventChecking_ptr
ReconnectDemo::CCM_Server_impl::get_for_clients()
    throw(CORBA::SystemException)
{
    return ReconnectDemo::CCM_EventChecking::_duplicate(m_facet.in());
}


//
// IDL:thalesgroup.com/ReconnectDemo/CCM_Server/push_event_sink:1.0
//
void 
ReconnectDemo::CCM_Server_impl::push_event_sink(ReconnectDemo::TestEvent*)
    throw(CORBA::SystemException)
{
    CCM_EventChecking_impl* facet =
        dynamic_cast<CCM_EventChecking_impl*>(m_facet.in());
    facet->_was_event_received = true;
}


//
// IDL:thalesgroup.com/ReconnectDemo/Registration/register:1.0
//
void
ReconnectDemo::CCM_Server_impl::test_supported()
    throw(CORBA::SystemException)
{
    // nothing to do
}

