#!/bin/sh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES 
# 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX-SI and THALES 2006. All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

PACK_TMP_DIR=/tmp/_ReconnectDemoPack_tmp

#
# Create Server assembly package
#
echo Create Server assembly package...

# clean tmp directory
rm -fr $PACK_TMP_DIR
mkdir $PACK_TMP_DIR
mkdir $PACK_TMP_DIR/meta-inf

# copy xml files
echo Copy descriptors...
cp @config.install.dir@/share/test_ccm_reconnect_java/ServerTestReconnect.cad $PACK_TMP_DIR/meta-inf
cp @config.install.dir@/share/test_ccm_reconnect_java/Server*.* $PACK_TMP_DIR

# copy idl file
echo Copy idl...
cp @config.install.dir@/idl/Reconnect.idl $PACK_TMP_DIR

# make links for libraries
ln -s @config.install.dir@/lib/java/libcdmwServerReconnectDemo.jar $PACK_TMP_DIR/libcdmwServerReconnectDemo.jar

echo Create assembly archive

OLD_DIR=`pwd`
cd $PACK_TMP_DIR
zip -r $OLD_DIR/JavaServerTestReconnect.aar *
cd $OLD_DIR


#
# Create Client assembly package
#
echo Create Client assembly package...

# clean tmp directory
rm -fr $PACK_TMP_DIR
mkdir $PACK_TMP_DIR
mkdir $PACK_TMP_DIR/meta-inf

# copy xml files
echo Copy descriptors...
cp @config.install.dir@/share/test_ccm_reconnect_java/ClientTestReconnect.cad $PACK_TMP_DIR/meta-inf
cp @config.install.dir@/share/test_ccm_reconnect_java/Client*.* $PACK_TMP_DIR

# copy idl file
echo Copy idl...
cp @config.install.dir@/idl/Reconnect.idl $PACK_TMP_DIR

# make links for libraries
ln -s @config.install.dir@/lib/java/libcdmwClientReconnectDemo.jar $PACK_TMP_DIR/libcdmwClientReconnectDemo.jar

echo Create assembly archive

OLD_DIR=`pwd`
cd $PACK_TMP_DIR
zip -r $OLD_DIR/JavaClientTestReconnect.aar *
cd $OLD_DIR

# clean tmp directory
rm -fr $PACK_TMP_DIR





