#include "clockservice/ControllerUpdate_impl.hpp"
#include "clockservice/Controller_impl.hpp"

#include <Foundation/common/Assert.hpp>

namespace Cdmw { namespace clock { namespace policy {

    ////////////////////////////////////////////////////////////////////////////

    ControllerUpdate_impl::ControllerUpdate_impl()
    {
    }
    
    ////////////////////////////////////////////////////////////////////////////
    
    ControllerUpdate_impl::~ControllerUpdate_impl()
    {
    }
    
    ////////////////////////////////////////////////////////////////////////////
    
    void
    ControllerUpdate_impl::update_controller_period (Controller_impl* ctrl,
                                                     TimeBase::TimeT  period)
    {
        if(!ctrl)
            return;
        ctrl->update_period(period);
    }
    
    ////////////////////////////////////////////////////////////////////////////
    
    void
    ControllerUpdate_impl::update_controller_offset (Controller_impl* ctrl,
                                                     TimeBase::TimeT  offset)
    {
        if(!ctrl)
            return;
        ctrl->update_offset(offset);
    }
    
    ////////////////////////////////////////////////////////////////////////////
    
    void
    ControllerUpdate_impl::freeze_controller(Controller_impl* ctrl)
    {
        if(!ctrl)
            return;
        ctrl->freezeTimerLockFree();
    }
    
    ////////////////////////////////////////////////////////////////////////////
    
    bool
    ControllerUpdate_impl::isValid(Cdmw::clock::ControllerEx_ptr controller)
    {
        CDMW_ASSERT(!CORBA::is_nil(controller));
        Controller_impl* controller_ptr =
            dynamic_cast<Controller_impl*>(controller);
        CDMW_ASSERT(controller_ptr);
        
        if(CORBA::is_nil(controller) || 
           controller_ptr == 0  ||
           (controller_ptr->executions() ==
            controller_ptr->execution_limit()))
           return false;
        //    throw CORBA::OBJECT_NOT_EXIST(Cdmw::OrbSupport::OBJECT_NOT_EXIST, 
        //                                  CORBA::COMPLETED_NO);            
        return true;
    }
    
} /* policy */ } /* clock */ } /* Cdmw */
                                                           
////////////////////////////////////////////////////////////////////////////////

    
