/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX-SI and THALES 2006. All rights reserved.
 *
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */
package cdmw.clock;

/**
 * <p>Title: CdmwCosClock</p>
 * <p>Description:  </p>
 * <p>Copyright: Copyright (c) 2006</p>
 * @author Francesca Annunziata
 * @version 
 */

import org.omg.PortableServer.*;
import org.omg.CORBA.ORB;
import cdmw.orbsupport.ORBSupport;
import org.omg.CosClockService.UtcTimeService;
import org.omg.CosClockService.UtcTimeServicePOATie;
import org.omg.CosClockService.ClockCatalogPackage.ClockEntry;
import org.omg.PortableServer.POA ;
import org.omg.CosClockService.ControlledClock;
import org.omg.CosClockService.ControlledClockPOATie;


public class CdmwCosClock 
{

    public final static String CLOCK_CATALOG_NAME = "ClockCatalog" ;
    private static org.omg.PortableServer.POA m_poa;


    public static boolean init(ORB orb)
    {
         ClockServiceJavaWrapper.startClockService(orb); 
         return true;
    }
    public static boolean init(ORB orb, String[] args)
    {
          
          // reference to POA
          try 
          {
              org.omg.CORBA.Object obj = orb.resolve_initial_references("RootPOA");
              m_poa = org.omg.PortableServer.POAHelper.narrow(obj);
              m_poa.the_POAManager().activate();
          
              // Registration for ClockCatalog
              ClockCatalogImpl catalog = new ClockCatalogImpl(orb);

              // UTC Registration
              UtcTimeServiceImpl   utctimeImpl   =  new UtcTimeServiceImpl(); 
              UtcTimeServicePOATie utctimePOAtie =  utctimeImpl._create(m_poa); 
              UtcTimeService utcclock            =  org.omg.CosClockService.UtcTimeServiceHelper.narrow(utctimePOAtie._this(orb));
              // register a valid clock
              ClockEntry entry = new ClockEntry(utcclock,"UTCTimeService");
              // add clocks to catalog
              catalog.register(entry);

              // -- Add Controlled Clocks to Clock Catalog --
              ControlledClockImpl controlledClockImpl = new ControlledClockImpl();
              ControlledClockPOATie controlledClockPOATie = controlledClockImpl._create(m_poa);
              ControlledClock controlledClock = org.omg.CosClockService.ControlledClockHelper.narrow(controlledClockPOATie._this(orb));
              entry = new ClockEntry(controlledClock,"ControlledClock");
              // add clocks to catalog
              catalog.register(entry);
              
               
              // write clockcatalog ior
              org.omg.CosClockService.ClockCatalog clockcatalog = catalog._this(orb);
              ORBSupport.registerInitialReference(orb,CLOCK_CATALOG_NAME, clockcatalog);
           } catch(Exception e) 
           {
              e.printStackTrace();
           }
           return true;

    }

     public static void close()
    {
       ClockServiceJavaWrapper.stopClockService();
    }

    org.omg.PortableServer.POA get_POA()
    {
        return null;
    }

}


