/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX-SI and THALES 2006. All rights reserved.
 *
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */

package cdmw.clock.test;
import cdmw.testutils.Testable;
import Cdmw.clock.ControllerEx;
//import Cdmw.clock.ControlledClockExOperations;
import Cdmw.clock.policy.*;
import cdmw.clock.policy.*;
import cdmw.clock.*;
//ControllerUpdateImpl;

import org.omg.CORBA.ORB;


public class ControllerUpdateTest extends Testable
{

   private final int NUMOFTESTS = 5;

   private cdmw.clock.ExecutorImpl executor;
   private ORB orb;
   private org.omg.CosClockService.PeriodicExecution.Periodic p;
   private Cdmw.clock.ControllerEx c;
   private cdmw.clock.policy.ControllerUpdateImpl u;
   private MyPeriodicExecution periodic;

   public ControllerUpdateTest (ORB orb)
   {
      this.name = "ControllerUpdateTest";
      this.out = System.out;
      this.executor = new cdmw.clock.ExecutorImpl();
      this.orb = orb;
      periodic = new MyPeriodicExecution();
      this.p = periodic._this(orb);
   }

   public boolean on_setTest(Cdmw.clock.ControllerEx ct)
   {
      try
      {
         this.c = (Cdmw.clock.ControllerEx)executor.enable_periodic_execution(p);
         this.u = new cdmw.clock.policy.ControllerUpdateImpl();
         u.on_set(ct);
      }
      catch (org.omg.CORBA.NO_IMPLEMENT ni)
      {
         System.out.println("Warnig (NO_IMPLEMENT): \"on_set\" operation is avaiable only at API level");
         return Macro.TEST_OK;
      }

      return Macro.TEST_OK;
   }

   public boolean on_set_rateTest(Cdmw.clock.ControllerEx ct)
   {
      try
      {
         this.c = (Cdmw.clock.ControllerEx)executor.enable_periodic_execution(p);
         this.u = new cdmw.clock.policy.ControllerUpdateImpl();
         u.on_set_rate(ct);
      }
      catch (org.omg.CORBA.NO_IMPLEMENT ni)
      {
         System.out.println("Warnig (NO_IMPLEMENT): \"on_set_rate\" operation is avaiable only at API level");
         return Macro.TEST_OK;
      }

      return Macro.TEST_OK;
   }

   public boolean on_pauseTest(Cdmw.clock.ControllerEx ct)
   {
      try
      {
         this.c = (Cdmw.clock.ControllerEx)executor.enable_periodic_execution(p);
         this.u = new cdmw.clock.policy.ControllerUpdateImpl();
         u.on_pause(ct);
      }
      catch (org.omg.CORBA.NO_IMPLEMENT ni)
      {
         System.out.println("Warnig (NO_IMPLEMENT): \"on_pause\" operation is avaiable only at API level");
         return Macro.TEST_OK;
      }

      return Macro.TEST_OK;
   }

   public boolean on_terminateTest(Cdmw.clock.ControllerEx ct)
   {
      try
      {
         this.c = (Cdmw.clock.ControllerEx)executor.enable_periodic_execution(p);
         this.u = new cdmw.clock.policy.ControllerUpdateImpl();
         u.on_terminate(ct);
      }
      catch (org.omg.CORBA.NO_IMPLEMENT ni)
      {
         System.out.println("Warnig (NO_IMPLEMENT): \"on_terminate\" operation is avaiable only at API level");
         return Macro.TEST_OK;
      }

      return Macro.TEST_OK;
   }

   public boolean on_resumeTest(Cdmw.clock.ControllerEx ct)
   {
      try
      {
         this.c = (Cdmw.clock.ControllerEx)executor.enable_periodic_execution(p);
         this.u = new cdmw.clock.policy.ControllerUpdateImpl();
         u.on_resume(ct);
      }
      catch (org.omg.CORBA.NO_IMPLEMENT ni)
      {
         System.out.println("Warnig (NO_IMPLEMENT): \"on_resume\" operation is avaiable only at API level");
         return Macro.TEST_OK;
      }

      return Macro.TEST_OK;
   }

   private void dummy (String name)
   {
      System.out.println("Warning (NO_IMPLEMENT): " + name + " is avaiable only at API level");
      throw new org.omg.CORBA.NO_IMPLEMENT();
   }

   public void doTests()
   {
      setNbOfRequestedTestOK(NUMOFTESTS);

      check(on_setTest(c));
      check(on_set_rateTest(c));
      check(on_pauseTest(c));
      check(on_terminateTest(c));
      check(on_resumeTest(c));
   }
}
