/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. It is derivative work based on PERCO Copyright (C) THALES
 * 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX-SI and THALES 2006. All rights reserved.
 *
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */

package cdmw.clock.test;
import cdmw.testutils.Testable;
import org.omg.CORBA.ORB;


public class ExecutorTest extends Testable
{

    private final int       NUMOFTESTS = 1;

    private cdmw.clock.ExecutorImpl executor;        
    private ORB orb;
       
    public ExecutorTest (ORB orb) 
    {
      this.name = "ExecutorTest";
      this.out = System.out;
      this.executor = new cdmw.clock.ExecutorImpl();
      this.orb = orb;
    }

    public boolean enable_periodic_executionTest()
    {
        try 
        {
           MyPeriodicExecution periodic = new MyPeriodicExecution();
           org.omg.CosClockService.PeriodicExecution.Periodic p = periodic._this(orb);
           org.omg.CosClockService.PeriodicExecution.Controller c = executor.enable_periodic_execution(p);
        }
        catch (org.omg.CORBA.NO_IMPLEMENT ni)
        {
            System.out.println("Warning (NO_IMPLEMENT): executor operations are avaiable only at API level");
            return Macro.TEST_OK;
         }

        return Macro.TEST_NOK;    
    }

    public void doTests() 
    {
        setNbOfRequestedTestOK(NUMOFTESTS);

        check(enable_periodic_executionTest()); 
    }
}

