/* =========================================================================== *
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX Sistemi Integrati.
 * Copyright (C) SELEX Sistemi Integrati 2004-2006. All rights reserved.
 *  
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 *  
 *  
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * =========================================================================== */


#ifndef CARDAMOM_CLIENT_EXECUTOR_PERIODIC_THREAD_HPP
#define CARDAMOM_CLIENT_EXECUTOR_PERIODIC_THREAD_HPP

// Cdmw Files
#include <Foundation/osthreads/Thread.hpp>

#include <CosClockService.stub.hpp>

class ClientExecutorPeriodicThread : public Cdmw::OsSupport::Thread
{
    public:

        ClientExecutorPeriodicThread(CosClockService::PeriodicExecution::Executor_var& executor,
                                     CosClockService::PeriodicExecution::Periodic_var& periodic)
            : m_FT_executor(executor),
              m_FT_periodic(periodic),
              m_stopped(false)
        {
        }

        virtual ~ClientExecutorPeriodicThread() throw ()
        {
        }
    
        void stop() throw ()
        {
            m_stopped = true;
        }

    protected:

        void run() throw();

    private:

        CosClockService::PeriodicExecution::Executor_var& m_FT_executor;
        CosClockService::PeriodicExecution::Periodic_var& m_FT_periodic;
        bool                                              m_stopped;
};

#endif // CARDAMOM_CLIENT_EXECUTOR_PERIODIC_THREAD_HPP
